diff --git a/src/common/gui/CModulationSourceButton.cpp b/src/common/gui/CModulationSourceButton.cpp
index e9109e8bc..d35a62bcb 100644
--- a/src/common/gui/CModulationSourceButton.cpp
+++ b/src/common/gui/CModulationSourceButton.cpp
@@ -298,8 +298,6 @@ CMouseEventResult CModulationSourceButton::onMouseDown(CPoint& where, const CBut
    if (storage)
       this->hideCursor = Surge::Storage::getUserDefaultValue(storage, "showCursorWhileEditing", 0);
 
-   onMouseDownCursorHelper(where);
-
    if (!getMouseEnabled())
       return kMouseDownEventHandledButDontNeedMovedOrUpEvents;
 
@@ -322,6 +320,9 @@ CMouseEventResult CModulationSourceButton::onMouseDown(CPoint& where, const CBut
          return kMouseDownEventHandledButDontNeedMovedOrUpEvents;
    }
 
+
+   onMouseDownCursorHelper(where);
+
    if (is_metacontroller && (buttons & kDoubleClick) && MCRect.pointInside(where) && controlstate == cs_none )
    {
       if (bipolar)
@@ -425,7 +426,10 @@ CMouseEventResult CModulationSourceButton::onMouseUp(CPoint& where, const CButto
    {
       endEdit();
 
-      endCursorHide(lastBarDraw);
+      if( event_is_drag )
+         endCursorHide(lastBarDraw);
+      else
+         endCursorHide();
    }
    controlstate = cs_none;
 
